package dk.nsp.idsas.util;

import dk.nsp.idsas.service.IdsasServiceException;
import org.apache.log4j.Logger;

import java.nio.ByteBuffer;

public class HashingUtil {
    private static final Logger logger = Logger.getLogger(HashingUtil.class);

    public static String createPatientIdHash(String patientId, byte[] salt) throws IdsasServiceException {
        byte[] patientIdByes = patientId.getBytes();
        byte[] combined = new byte[patientIdByes.length + salt.length];

        ByteBuffer buffer = ByteBuffer.wrap(combined);
        buffer.put(patientIdByes);
        buffer.put(salt);

        String output;
        try {
            output = UUIDv5.generateUUIDFromBytes(buffer.array()).toString();
        } catch (Exception e) {
            logger.error(e.getMessage(), e);
            throw new IdsasServiceException("Error creating patient id hash", FaultCode.CREATE_BLURRING_ERROR, false);
        }
        return output;
    }
}
